// Serial.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>

#include "moxa\devices.h"

int _tmain(int argc, _TCHAR* argv[])
{
	BYTE pattern[20] = "1234567890";      // data
	HANDLE hSerial = NULL;                // serial port handle
	DCB dcb;                              // setting structure of Serial port
	WCHAR szPort[10] = L"COM3:";          // define COM3: to be the port of data sent
	
	// Open serial port
	hSerial = CreateFile( szPort, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	if ( hSerial != INVALID_HANDLE_VALUE )
	{
		// Get Port setting structure
		GetCommState(hSerial, &dcb);

		dcb.BaudRate = 115200;                     // set baud rate to 115200 bps
		dcb.fRtsControl = RTS_CONTROL_HANDSHAKE;   // set Hardware flow control
		dcb.ByteSize = 8;                          // data size = 8
		dcb.StopBits = ONESTOPBIT;                 // stop bit = 1
		dcb.Parity = NOPARITY;                     // no parity

		// Update Port setting structure
		SetCommState(hSerial, &dcb);

		DWORD dwReturned = 0;
		// set Mode to RS232
		BYTE bMode = RS232_MODE;
		DeviceIoControl(hSerial, MOXA_SET_OP_MODE, &bMode, sizeof(BYTE), NULL, 0, &dwReturned, NULL);

		// send pattern
		WriteFile( hSerial, pattern, 10 /* send 10 bytes only */, &dwReturned, NULL);

		// Close Serial Port Handle
		CloseHandle(hSerial);
	}

	return 0;
}

